/*
 * ***** BEGIN LICENSE BLOCK *****
 *
 * Copyright (c) 2011 ICSI Center for Internet Research (ICIR)
 * All rights reserved.
 *
 * See LICENSE.txt for license and terms of usage. 
 *
 * ***** END LICENSE BLOCK *****
 */
 
/*-------------------------- Temporary Logging Start -------------------------*/ 
var write = "";

function Log(txt) {
	write += txt + "\n";
}

function WriteToDisk(error) {
   /*var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
   file.initWithPath("/tmp");
   file.append("Priv.log");
   if(!file.exists())
       file.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
   var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
   foStream.init(file, 0x02 | 0x10, 0666, 0);
   var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
   converter.init(foStream, "UTF-8", 0, 0);
   converter.writeString(error);
   converter.close();*/
   var file = FileUtils.getFile("TmpD", ["Priv.log"]);
   writeToDisk(file, error);
   write = "";
}
/*--------------------------- Temporary Logging End --------------------------*/ 

var Cc = Components.classes;
var Ci = Components.interfaces;

var loadInProgress = 0;

var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
var ssm = Cc["@mozilla.org/scriptsecuritymanager;1"].getService(Ci.nsIScriptSecurityManager);
var dsm = Cc["@mozilla.org/dom/storagemanager;1"].getService(Ci.nsIDOMStorageManager);

var totalHTTPsend = 0;
var totalHTTPrecv = 0;

Components.utils.import("resource://fathom/SysUtils.jsm");
Components.utils.import("resource://gre/modules/NetUtil.jsm"); 
Components.utils.import("resource://gre/modules/FileUtils.jsm");  

//var sysutils = null;
const HISTORY_LENGTH = 2000;
//const MEMORY_LENGTH = 360;

var syshistory = null;
var baselineFile = FileUtils.getFile("TmpD", ["baseline.txt"]);
if(!baselineFile.exists())
	baselineFile.create(Ci.nsIFile.NORMAL_FILE_TYPE, 0755);  

NetUtil.asyncFetch(baselineFile, function(inputStream, status) {  
	if (!Components.isSuccessCode(status)) {  
		return;  
	}  
	try {
		var data = NetUtil.readInputStreamToString(inputStream, inputStream.available());
		syshistory = JSON.parse(data);
	} catch(e) {
		//Log("Could not parse data and set syshistory.");
		syshistory = {
			cpu : [],
			wifi : [],
			crosstraffic : [],
			ffxMemory : []
		};
	}
});

function writeToDisk(file, data) {
    /*var ostream = FileUtils.openSafeFileOutputStream(file, FileUtils.MODE_WRONLY | FileUtils.MODE_APPEND)*/
    var ostream = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	ostream.init(file, 0x02|0x08|0x10, 0644, 1);
      
    var converter = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter);  
    converter.charset = "UTF-8";  
    var istream = converter.convertToInputStream(data);

    NetUtil.asyncCopy(istream, ostream, function(status) {  
      if (!Components.isSuccessCode(status)) {  
        return;  
      }  
    });
}
/*
function writeToDisk(file, data) {
  	if(!file.exists())
		file.create(Ci.nsIFile.NORMAL_FILE_TYPE, 0755); 
		
    var ostream = FileUtils.openSafeFileOutputStream(file, FileUtils.MODE_WRONLY)  
      
    var converter = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter);  
    converter.charset = "UTF-8";  
    var istream = converter.convertToInputStream(data);  

    NetUtil.asyncCopy(istream, ostream, function(status) {  
      if (!Components.isSuccessCode(status)) {  
        return;  
      }  
    });  
}
*/
function saveFFxMemoryUsage() {
	var start = Date.now();
	var mgr = Cc["@mozilla.org/memory-reporter-manager;1"].getService(Ci.nsIMemoryReporterManager);
	var e = mgr.enumerateReporters();
	while (e.hasMoreElements()) {
    	var mr = e.getNext().QueryInterface(Ci.nsIMemoryReporter);
		if(mr.path == "heap-committed") {
	 		var val = mr.memoryUsed/(1024 * 1024);
			break;
		}
	}
	var mid = Date.now();
	var mem = syshistory.ffxMemory;
	if(mem.length == HISTORY_LENGTH)
		mem.shift();
	mem.push({memory: val.toFixed(3), time: Date.now()});
	//Log("Done = " + (Date.now() - start) + " :: query = " + (mid - start));
}

function saveCPUHistory(val) {
	var start = Date.now();
	var cpu = syshistory.cpu;
	if(cpu.length == HISTORY_LENGTH)
		cpu.shift();
	cpu.push(JSON.parse(val));
	var end = Date.now();
	//Log("CPU took = " + (end-start))
}

function saveWiFiHistory(val) {
	var wifi = syshistory.wifi;
	if(wifi.length == HISTORY_LENGTH)
		wifi.shift();
	wifi.push(JSON.parse(val));
}

function saveNWHistory(val) {
	var obj = JSON.parse(val);
	var crosstraffic = syshistory.crosstraffic;
	if(crosstraffic.length == HISTORY_LENGTH)
		crosstraffic.shift();
	obj.httpsend = totalHTTPsend;
	obj.httprecv = totalHTTPrecv;
	crosstraffic.push(obj);
}

var timerevent = {
	observe: function(subject, topic, data) {
		{//if(loadInProgress) {
			//Log("Load request in progress.");
			//return;
		}
		// get wifi, cross-traffic, system info, ffxMemuse
		
		var getHandlToFathom = function() {
			var handle = null;
			var doc = gBrowser.contentDocument;
			if(doc && doc.defaultView) {
				var win = doc.defaultView;
				if(win.fathom)
					handle = new SysUtils(win.fathom);
			}
			return handle;
		}
		
		var sysutils = getHandlToFathom();
		if(sysutils) {
			var lstart = Date.now();
			sysutils.CPUInfo(saveCPUHistory);
			var mstart = Date.now();
			sysutils.wifiInfo(saveWiFiHistory);
			var nstart = Date.now();
			sysutils.currentThroughput(saveNWHistory);
			var ostart = Date.now();
			saveFFxMemoryUsage();
			var stringify = Date.now();
			/*var tmp = JSON.stringify(syshistory);*/
			var strend = Date.now();
			// add tmp to local storage for each window
			/*setLocalStorage(tmp);*/
			var now = Date.now();
			Log("Logging system metrics took = " + (now - lstart) + " :: cpu = " + (mstart - lstart) + " :: wifi = " + (nstart - mstart) + " :: nw = " + (ostart - nstart) + " :: ffx = " + (stringify - ostart) + " :: storing in DOM storage took = " + (now - stringify));
			//Log("stringifying (" + (tmp.length) + ") took = " + (strend-stringify) + " :: storage took = " + (now-strend))
		} else {
			//Log("sysutils is null");
		}
		getHandlToFathom = null;
		sysutils = null;
	}
}

function domlocalstorage(url, data) {
	var start = Date.now();
	var uri = ios.newURI(url, "", null);
	var principal = ssm.getCodebasePrincipal(uri);
	var storage = dsm.getLocalStorageForPrincipal(principal, "");
	storage.setItem("baseline", data);
	var end = Date.now();
	//Log("per window storing took = " + (end-start))
}

function setLocalStorage(data) {
   	var start = Date.now();
	var tabbrowser = window.gBrowser;  
    var numTabs = tabbrowser.browsers.length;  
    for (var index = 0; index < numTabs; index++) {  
    	var currentBrowser = tabbrowser.getBrowserAtIndex(index);
    	var win = currentBrowser.contentWindow;
    	if(win && win.location) {
    		//Log("Storage :: Index = " + index + " : window = " + win.location);
    		domlocalstorage(win.location, data);
    	}
    }
   	var end = Date.now();
	//Log("total storing took = " + (end-start))

}

var filewrite = {
	observe: function(subject, topic, data) {
		writeToDisk(baselineFile, JSON.stringify(syshistory));
		window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils).garbageCollect();
	}
}

/*var timer = Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
timer.init(timerevent, 5*1000, Ci.nsITimer.TYPE_REPEATING_PRECISE);

// this timer runs every 60 secs and dumps history to disk
var timer1 = Cc["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
timer1.init(filewrite, 30*1000, Ci.nsITimer.TYPE_REPEATING_PRECISE);*/
