/*
 * ***** BEGIN LICENSE BLOCK *****
 *
 * Copyright (c) 2011 ICSI Center for Internet Research (ICIR)
 * All rights reserved.
 *
 * See LICENSE.txt for license and terms of usage. 
 *
 * ***** END LICENSE BLOCK *****
 */

util.registerAction('getSystemInfo');
util.registerAction('getHostIP');

function getSystemInfo(param) {
	var info = newBuffer(256);
	var val = null;
	switch(param) {
		case "hostname":
			val = NSPR.util.PR_SI_HOSTNAME;
			break;
		case "system":
			val = NSPR.util.PR_SI_SYSNAME;
			break;
		case "release":
			val = NSPR.util.PR_SI_RELEASE;
			break;
		case "architecture":
			val = NSPR.util.PR_SI_ARCHITECTURE;
			break;
		case "fullhostname":
			val = NSPR.util.PR_SI_HOSTNAME_UNTRUNCATED;
			break;
		default:
			break;
	}
	if(!val)
		return "No information found. -- param = " + param;
	NSPR.util.PR_GetSystemInfo(val, info, 256);
	for(var tmp = "", i = 0; info[i] != '0'; i++)
		tmp += String.fromCharCode(info[i]);
	return tmp;
}

function getHostIP(param, fd) {
	var sockfd = util.getRegisteredSocket(fd);
	switch(param) {
		case "ipv4":
			return NSPR.util.GetHostIP(sockfd);
		case "ipv6":
		default:
			return "Not available.";
	}
}
